najjar.biz/Models/EmployeesVacation.cs
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Web;

namespace najjar.biz.Models
{
    public class EmployeesVacation
    {
        [Key]
        public int id { get; set; }

        [Required]
        [Display(Name = "CreationDate")]
        public DateTime CreationDate { get; set; }

        [Required]
        [Display(Name = "Last Modification Date")]
        public DateTime LastModificationDate { get; set; }

        [Required]
        [Display(Name = "Vacation Start Date")]
        public DateTime startDate { get; set; }

        [Display(Name = "Vacation End Date")]
        public DateTime EndDate { get; set; }

        [Display(Name = "Duration")]
        public int Duration { get; set; }

        [Display(Name = "Status")]
        public String Status { get; set; }
        
        public int EmployeeId { get; set; }
    }
}

najjar.biz/Controllers/EmployeesVacationController.cs
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Linq;
using System.Net;
using System.Web;
using System.Web.Mvc;
using najjar.biz.Models;
using najjar.biz.Context;
using Microsoft.AspNet.Identity;
using Microsoft.AspNet.Identity.EntityFramework;

namespace najjar.biz.Controllers
{
    public class EmployeesVacationController : Controller
    {
        private ApplicationDataContext db = new ApplicationDataContext();

        // GET: /EmployeesVacation/
        public ActionResult Index()
        {
            fillUserData();
            return View(db.EmployeesVacations.ToList());
        }

        // GET: /EmployeesVacation/
        public ActionResult EmployeeVacation(int  Employeeid)
        {
            fillUserData();
            return View(db.EmployeesVacations.Where(x => x.EmployeeId == Employeeid).ToList());
        }


        // GET: /EmployeesVacation/Details/5
        public ActionResult Details(int? id)
        {
            fillUserData();
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            EmployeesVacation employeesvacation = db.EmployeesVacations.Find(id);
            if (employeesvacation == null)
            {
                return HttpNotFound();
            }
            return View(employeesvacation);
        }

        // GET: /EmployeesVacation/Create
        public ActionResult Create()
        {
            fillUserData();
            return View();
        }

        // POST: /EmployeesVacation/Create
        // To protect from overposting attacks, please enable the specific properties you want to bind to, for 
        // more details see http://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Create([Bind(Include="id,startDate,EndDate,Duration,EmployeeId,Status")] EmployeesVacation employeesvacation)
        {
            fillUserData();
            if (ModelState.IsValid)
            {
                employeesvacation.CreationDate = DateTime.Now;
                employeesvacation.LastModificationDate = DateTime.Now;
                employeesvacation.Duration = (employeesvacation.EndDate - employeesvacation.startDate).Days ;
                db.EmployeesVacations.Add(employeesvacation);
                db.SaveChanges();
                return RedirectToAction("EmployeeVacation", new { Employeeid = employeesvacation.EmployeeId});
            }

            return View(employeesvacation);
        }

        // GET: /EmployeesVacation/Edit/5
        public ActionResult Edit(int? id)
        {
            fillUserData();
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            EmployeesVacation employeesvacation = db.EmployeesVacations.Find(id);
            if (employeesvacation == null)
            {
                return HttpNotFound();
            }
            return View(employeesvacation);
        }

        // POST: /EmployeesVacation/Edit/5
        // To protect from overposting attacks, please enable the specific properties you want to bind to, for 
        // more details see http://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Edit([Bind(Include="id,startDate,EndDate,Status")] EmployeesVacation employeesvacation)
        {
            fillUserData();
            if (ModelState.IsValid)
            {
                EmployeesVacation vacOld = db.EmployeesVacations.Find(employeesvacation.id);
                vacOld.startDate = employeesvacation.startDate;
                vacOld.EndDate = employeesvacation.EndDate;
                vacOld.Status = employeesvacation.Status;
                vacOld.Duration = (vacOld.EndDate - vacOld.startDate).Days;
                vacOld.LastModificationDate = DateTime.Now;
                db.Entry(vacOld).State = EntityState.Modified;
                db.SaveChanges();
                return RedirectToAction("EmployeeVacation", new { Employeeid = vacOld.EmployeeId });
            }
            return View(employeesvacation);
        }

        // GET: /EmployeesVacation/Delete/5
        public ActionResult Delete(int? id)
        {
            fillUserData();
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            EmployeesVacation employeesvacation = db.EmployeesVacations.Find(id);
            if (employeesvacation == null)
            {
                return HttpNotFound();
            }
            return View(employeesvacation);
        }

        // POST: /EmployeesVacation/Delete/5
        [HttpPost, ActionName("Delete")]
        [ValidateAntiForgeryToken]
        public ActionResult DeleteConfirmed(int id)
        {
            fillUserData();
            EmployeesVacation employeesvacation = db.EmployeesVacations.Find(id);
            db.EmployeesVacations.Remove(employeesvacation);
            db.SaveChanges();
            return RedirectToAction("EmployeeVacation", new { Employeeid = employeesvacation.EmployeeId });
        }

        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                db.Dispose();
            }
            base.Dispose(disposing);
        }

        public void fillUserData()
        {
            var userManager = new UserManager<ApplicationUser>(new UserStore<ApplicationUser>(new ApplicationDataContext()));
            var user = userManager.FindById(User.Identity.GetUserId());
            ViewBag.CurrentUser = user;
        }
    }
}

najjar.biz/Views/EmployeesVacation/Create.cshtml
@model najjar.biz.Models.EmployeesVacation

@{
    ViewBag.Title = "Create";
    Layout = "~/Views/Shared/_Admin_Layout.cshtml";
    var employeeId = Request.QueryString["Employeeid"];
}

<h2>Create</h2>

@using (Html.BeginForm()) 
{
    @Html.AntiForgeryToken()
    
    <div class="form-horizontal">
        <h4>EmployeesVacation</h4>
        <hr />
        @Html.ValidationSummary(true)

        <div class="form-group">
            @Html.LabelFor(model => model.startDate, new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.TextBoxFor(model => model.startDate, new { type = "date" })
                @Html.ValidationMessageFor(model => model.startDate)
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.EndDate, new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.TextBoxFor(model => model.EndDate, new { type = "date" })
                @Html.ValidationMessageFor(model => model.EndDate)
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Status, new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.DropDownList("Status", new List<SelectListItem>
                               { new SelectListItem { Text="Confirmed", Value="Confirmed"},
                                    new SelectListItem{Text="Not Confirmed", Value="Not Confirmed"}
                                 }, "Select Status")
                @Html.ValidationMessageFor(model => model.Status)
            </div>
        </div>
        <div class="form-group">
            <div class="col-md-offset-2 col-md-10">
                @Html.HiddenFor(model => model.EmployeeId, new { Value = employeeId })
                <input type="submit" value="Create" class="btn btn-default" />
            </div>
        </div>
    </div>
}

<div>
    @Html.ActionLink("Back to List", "EmployeeVacation", "EmployeesVacation", new { Employeeid = employeeId }, null)
</div>

najjar.biz/Views/EmployeesVacation/Delete.cshtml
@model najjar.biz.Models.EmployeesVacation

@{
    ViewBag.Title = "Delete";
    Layout = "~/Views/Shared/_Admin_Layout.cshtml";
}

<h2>Delete</h2>

<h3>Are you sure you want to delete this?</h3>
<div>
    <h4>EmployeesVacation</h4>
    <hr />
    <dl class="dl-horizontal">
        <dt>
            @Html.DisplayNameFor(model => model.CreationDate)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.CreationDate)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.LastModificationDate)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.LastModificationDate)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.startDate)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.startDate)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.EndDate)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.EndDate)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.Duration)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Duration)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.EmployeeId)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.EmployeeId)
        </dd>

    </dl>

    @using (Html.BeginForm()) {
        @Html.AntiForgeryToken()

        <div class="form-actions no-color">
            <input type="submit" value="Delete" class="btn btn-default" /> |
            @Html.ActionLink("Back to List", "EmployeeVacation", "EmployeesVacation", new { Employeeid = Model.EmployeeId }, null)
        </div>
    }
</div>

najjar.biz/Views/EmployeesVacation/Details.cshtml
@model najjar.biz.Models.EmployeesVacation

@{
    ViewBag.Title = "Details";
    Layout = "~/Views/Shared/_Admin_Layout.cshtml";
}

<h2>Details</h2>

<div>
    <h4>EmployeesVacation</h4>
	<hr />
    <dl class="dl-horizontal">
        <dt>
            @Html.DisplayNameFor(model => model.CreationDate)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.CreationDate)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.LastModificationDate)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.LastModificationDate)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.startDate)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.startDate)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.EndDate)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.EndDate)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.Duration)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Duration)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.EmployeeId)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.EmployeeId)
        </dd>

    </dl>
</div>
<p>
    @Html.ActionLink("Edit", "Edit", new { id = Model.id }) |
    @Html.ActionLink("Back to List", "Index")
</p>

najjar.biz/Views/EmployeesVacation/Edit.cshtml
@model najjar.biz.Models.EmployeesVacation

@{
    ViewBag.Title = "Edit";
    Layout = "~/Views/Shared/_Admin_Layout.cshtml";
}

<h2>Edit</h2>

@using (Html.BeginForm())
{
    @Html.AntiForgeryToken()
    
    <div class="form-horizontal">
        <h4>EmployeesVacation</h4>
        <hr />
        @Html.ValidationSummary(true)
        @Html.HiddenFor(model => model.id)

        

        

        <div class="form-group">
            @Html.LabelFor(model => model.startDate, new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.TextBoxFor(model => model.startDate, new { type = "date", @Value = Model.startDate.ToString("yyyy-MM-dd") })
                @Html.ValidationMessageFor(model => model.startDate)
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.EndDate, new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.TextBoxFor(model => model.EndDate, new { type = "date", @Value = Model.EndDate.ToString("yyyy-MM-dd") })
                @Html.ValidationMessageFor(model => model.EndDate)
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Status, new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.DropDownList("Status", new List<SelectListItem>
                               { new SelectListItem { Text="Confirmed", Value="Confirmed"},
                                    new SelectListItem{Text="Not Confirmed", Value="Not Confirmed"}
                                 }, "Select Status")
                @Html.ValidationMessageFor(model => model.Status)
            </div>
        </div>
                
        
        <div class="form-group">
            <div class="col-md-offset-2 col-md-10">
                <input type="submit" value="Save" class="btn btn-default" />
            </div>
        </div>
    </div>
}

<div>
    @Html.ActionLink("Back to List", "EmployeeVacation", "EmployeesVacation", new { Employeeid = Model.EmployeeId }, null)
</div>

najjar.biz/Views/EmployeesVacation/EmployeeVacation.cshtml
@model IEnumerable<najjar.biz.Models.EmployeesVacation>

@{
    ViewBag.Title = "EmployeeVacation";
    Layout = "~/Views/Shared/_Admin_Layout.cshtml";
    var vacId = Request.QueryString["Employeeid"];
}
<script src="https://cdnjs.cloudflare.com/ajax/libs/html2canvas/0.4.1/html2canvas.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/jspdf/1.5.3/jspdf.debug.js"
        integrity="sha384-NaWTHo/8YCBYJ59830LTz/P4aQZK1sS0SneOgAvhsIl3zBu8r9RevNg5lHCHAuQ/"
        crossorigin="anonymous"></script>

<div class="row">
    <div class="col-md-4">

        <ul class="nav nav-stacked nav-pills">
            <li id="PersonalInfo" style="color: #071689 !important; font-size: larger">
                @Html.ActionLink("Personal Information", "PersonalPage", "Employee", new { Employeeid = vacId }, null)
            </li>
            <li id="SalaryInfo" style="color: #071689 !important; font-size: larger">
                @Html.ActionLink("Salary Information", "SalaryInfo", "Employee", new { Employeeid = vacId }, null)
            </li>
            <li id="EmployeeDocs" style="color: #071689 !important; font-size: larger">
                @Html.ActionLink("My Documents", "EmployeeDocs", "Support", new { Employeeid = vacId }, null)
            </li>
            <li id="EmployeeVacation" class="active" style="color: #071689 !important; font-size: larger">
                @Html.ActionLink("Employee Vacation", "EmployeeVacation", "EmployeesVacation", new { Employeeid = vacId }, null)
            </li>

            <li id="EmployeeRating" style="color: #071689 !important; font-size: larger">
                @Html.ActionLink("Employee Rating", "EmployeeRating", "EmployeeRating", new { Employeeid = vacId }, null)
            </li>
            <li id="EmployeeRating" style="color: #071689 !important; font-size: larger">
                @Html.ActionLink("Termination Info", "TerminationInfo", "Employee", new { Employeeid = vacId }, null)
            </li>
            <li id="EmployeeRating" style="color: #071689 !important; font-size: larger">
                @Html.ActionLink("Exams Info", "ExamsInfo", "OnlineExam", new { Employeeid = vacId }, null)
            </li>
        </ul>
    </div>

    <div class="col-md-8" id="PersonalInfoDV">

        <h2 class="text-center" style="color: #071689 !important;">Employee Vacations</h2>

        @if (User.IsInRole("Administrator"))
        {
            @*<p>
                    @Html.ActionLink("Create New", "Create", new { Employeeid = vacId })

                </p>*@

            <div class="row" style="margin-top:3%">
                <div>
                    <input type="button"
                           class="btn btn-primary" style="float:right;" value="Add New Vacation"
                           onclick="location.href='@Url.Action("Create", new { Employeeid = vacId })'" />
                </div>
            </div>
        }
        <table class="table" style="margin-top:3%">
            <tr>

                <th>
                    @Html.DisplayNameFor(model => model.startDate)
                </th>
                <th>
                    @Html.DisplayNameFor(model => model.EndDate)
                </th>
                <th>
                    @Html.DisplayNameFor(model => model.Duration)
                </th>
                <th>
                    @Html.DisplayNameFor(model => model.Status)
                </th>
                <th>
                    @Html.DisplayNameFor(model => model.EmployeeId)
                </th>
                <th></th>
            </tr>

            @foreach (var item in Model)
            {
                <tr>

                    <td>
                        @Html.DisplayFor(modelItem => item.startDate)
                    </td>
                    <td>
                        @Html.DisplayFor(modelItem => item.EndDate)
                    </td>
                    <td>
                        @Html.DisplayFor(modelItem => item.Duration)
                    </td>
                    <td>
                        @Html.DisplayFor(modelItem => item.Status)
                    </td>
                    <td>
                        @Html.DisplayFor(modelItem => item.EmployeeId)
                    </td>
                    <td>
                        @if (User.IsInRole("Administrator"))
                        {
                            <div>
                                @Html.ActionLink("Edit", "Edit", new { id = item.id }) |
                                @Html.ActionLink("Delete", "Delete", new { id = item.id })
                            </div>
                        }
                    </td>
                </tr>
            }



        </table>

    </div>



    <!-- /.row -->
</div>

najjar.biz/Views/EmployeesVacation/Index.cshtml
@model IEnumerable<najjar.biz.Models.EmployeesVacation>

@{
    ViewBag.Title = "Index";
    Layout = "~/Views/Shared/_Admin_Layout.cshtml";
}

<div>
    <h2 style="color: #8b224e">Employees Vacation Management</h2>

    <br />
    <p style="float:right;text-decoration-color:white;">

        <button class="btn btn-primary btn-default" onclick="location.href='@Url.Action("Create", "EmployeesVacation")'">
            <i class="fa fa-plus-square pull-right" style="font-size:x-large"></i> Create New Employees Vacation
        </button>

    </p>

    <table id="myTable" class="table table table-striped table-hover col-sm-10 col-md-10">
        <thead>
            <tr>
                <th>
                    @Html.DisplayNameFor(model => model.CreationDate)
                </th>
                <th>
                    @Html.DisplayNameFor(model => model.LastModificationDate)
                </th>
                <th>
                    @Html.DisplayNameFor(model => model.startDate)
                </th>
                <th>
                    @Html.DisplayNameFor(model => model.EndDate)
                </th>
                <th>
                    @Html.DisplayNameFor(model => model.Duration)
                </th>
                <th>
                    @Html.DisplayNameFor(model => model.EmployeeId)
                </th>
                <th></th>
            </tr>
        </thead>
        <tbody>
            @foreach (var item in Model)
            {
                <tr>
                    <td>
                        @Html.DisplayFor(modelItem => item.CreationDate)
                    </td>
                    <td>
                        @Html.DisplayFor(modelItem => item.LastModificationDate)
                    </td>
                    <td>
                        @Html.DisplayFor(modelItem => item.startDate)
                    </td>
                    <td>
                        @Html.DisplayFor(modelItem => item.EndDate)
                    </td>
                    <td>
                        @Html.DisplayFor(modelItem => item.Duration)
                    </td>
                    <td>
                        @Html.DisplayFor(modelItem => item.EmployeeId)
                    </td>
                    <td>
                        <a href="@Url.Action("Edit", "EmployeesVacation", new { id = item.id })">
                            <i class="fa fa-pencil" style="font-size:x-large" data-toggle="tooltip" title="Edit Employee"></i>
                        </a>
                        &nbsp; &nbsp;
                        @*@Html.ActionLink("Edit", "Edit", new { id = item.id }) |*@
                        @*@Html.ActionLink("Details", "Details", new { id = item.id }) |*@
                        <a href="@Url.Action("Delete", "EmployeesVacation", new { id = item.id })" data-toggle="tooltip" title="Delete Employee">
                            <i class="fa fa-remove" style="font-size:x-large"></i>
                        </a>
                        @*@Html.ActionLink("Delete", "Delete", new { id = item.id })*@
                    </td>
                </tr>
            }
        </tbody>
    </table>
    <br />


</div>
<!-- Modal -->
<div id="myModal" class="modal fade" role="dialog">
    <div class="modal-dialog">
        <!-- Modal content-->
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal">&times;</button>
                <h2 class="modal-title">Final notes before the exam</h2>
            </div>
            <div class="modal-body">
                <p style="font-size:x-large">Please don't close browser session before you answer all the questions or you will fail in the exam!.</p>
            </div>
            <div class="modal-footer">
                @using (Html.BeginForm("Register", "OnlineExam", FormMethod.Post, new { @id = "registerForm" }))
                {
                    @Html.Hidden("TestId", Model.Test.Id)
                    @Html.Hidden("employee_code", Model.employee.EmployeeCode)
                    <a href="javascript:void(0);" onclick="getElementById('registerForm').submit()" class="btn btn-primary">
                        Start Exam
                    </a>

                }
            </div>
        </div>
    </div>
</div>